from __future__ import annotations
from typing import TypeVar, TYPE_CHECKING
from DAP.Crypto import Sign, Pkey
from CellFrame.Chain import ChainAddr

if TYPE_CHECKING:
    from .net import CFNet


class CFSign:
    __slots__ = ["_origin_sign", "net", "type", "pkey", "size", "pkey_hash", "address"]

    def __init__(self, sign: Sign, net: CFNet):
        self._origin_sign = sign
        self.net = net
        self.type = str(sign.type)
        self.pkey = CFPkey(sign.pkey)
        self.size = sign.size
        self.pkey_hash = str(self._origin_sign.pkeyHash)
        self.address = str(ChainAddr.fill(self._origin_sign.type, self._origin_sign.pkeyHash, self.net._origin_net.id))


class CFPkey:
    def __init__(self, pkey: Pkey):
        self._origin_pkey = pkey
        self.type = pkey.type
        self.size = pkey.size
