from typing import Callable
from CellFrame.Chain import GlobalDB


class GDBGroup:
    def __init__(self, group):
        self.group = group

    def set(self, key, value) -> bool:
        return GlobalDB.set(key, self.group, value)

    def get(self, key, default=None):
        return GlobalDB.get(key, self.group) or default

    def delete(self, key):
        GlobalDB.delete(key, self.group)

    def group_list(self):
        return GlobalDB.grLoad(self.group)

    @staticmethod
    def add_to_white_list(net_name: str, group_mask: str, callback: Callable, callback_args: list):
        """
        group_mask example: "raiden.emission-center.*
        """
        GlobalDB.addSyncExtraGroup(net_name, group_mask, callback, callback_args)
